## libodsstream 0.0.1-1

=== CMakeLists.txt ===
# cmake helps to compile "libodsstream"
# please install the cmake package depending on your linux distribution
# and type in the libodsstream root directory :
# cmake .
# make
# make install
cmake_minimum_required(VERSION 2.6)

PROJECT(libodsstream CXX C)


# Project version
# 

SET (LIBODSSTREAM_MAJOR_VERSION 0)
SET (LIBODSSTREAM_MINOR_VERSION 0)
SET (LIBODSSTREAM_PATCH_LEVEL   1)
SET (LIBODSSTREAM_VERSION
  "${LIBODSSTREAM_MAJOR_VERSION}.${LIBODSSTREAM_MINOR_VERSION}.${LIBODSSTREAM_PATCH_LEVEL}")
SET (LIBODSSTREAM_LIB_NAME "libodsstream")
SET (LIBODSSTREAM_LIB_VERSION ${LIBODSSTREAM_VERSION})
SET (LIBODSSTREAM_LIB_SOVERSION ${LIBODSSTREAM_MAJOR_VERSION})


if (NOT CMAKE_INSTALL_PREFIX)
  SET (CMAKE_INSTALL_PREFIX /usr/local)
endif (NOT CMAKE_INSTALL_PREFIX)

if (NOT CMAKE_BUILD_TYPE)
#SET(CMAKE_BUILD_TYPE "Release")
#SET(CMAKE_BUILD_TYPE "RelWithDebInfo")
SET( CMAKE_BUILD_TYPE "Debug")
endif (NOT CMAKE_BUILD_TYPE)
MESSAGE("CMAKE_BUILD_TYPE : ${CMAKE_BUILD_TYPE}")

IF(CMAKE_BUILD_TYPE MATCHES "Release")
  MESSAGE("compiling as release version")
  ADD_DEFINITIONS("-DQT_NO_DEBUG_OUTPUT")
ENDIF( CMAKE_BUILD_TYPE MATCHES "Release" )

IF(CMAKE_BUILD_TYPE MATCHES "Debug")
  MESSAGE("compiling as debug version")
ENDIF( CMAKE_BUILD_TYPE MATCHES "Debug" )

IF(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
  MESSAGE("compiling as release with debug info version")
ENDIF( CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo" )


SET(CPACK_CMAKE_GENERATOR "Unix Makefiles")
SET(CPACK_GENERATOR "STGZ;TGZ;TZ")
SET(CPACK_OUTPUT_CONFIG_FILE "./CPackConfig.cmake")
#SET(CPACK_PACKAGE_DESCRIPTION_FILE ${LIBODSSTREAM_SOURCE_DIR}/COPYING)
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "library to read and write ODS files using streams")
SET(CPACK_PACKAGE_EXECUTABLES "libodsstream")
SET(CPACK_SOURCE_PACKAGE_FILE_NAME "libodsstream-${LIBODSSTREAM_VERSION}")
SET(CPACK_SYSTEM_NAME "Linux-i686")
SET(CPACK_PACKAGE_FILE_NAME "libodsstream-${LIBODSSTREAM_VERSION}-${CPACK_SYSTEM_NAME}")
SET(CPACK_PACKAGE_INSTALL_DIRECTORY "libodsstream ${LIBODSSTREAM_VERSION}")
SET(CPACK_PACKAGE_INSTALL_REGISTRY_KEY "libodsstream ${LIBODSSTREAM_VERSION}")
SET(CPACK_PACKAGE_NAME "libodsstream")
SET(CPACK_PACKAGE_VENDOR "PAPPSO")
SET(CPACK_PACKAGE_VERSION ${LIBODSSTREAM_VERSION})
SET(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_SOURCE_DIR}/debian/copyright)
SET(CPACK_RESOURCE_FILE_README ${CMAKE_SOURCE_DIR}/README)
SET(CPACK_RESOURCE_FILE_WELCOME ${CMAKE_SOURCE_DIR}/README)
SET(CPACK_SOURCE_GENERATOR "TGZ;TZ")
SET(CPACK_SOURCE_OUTPUT_CONFIG_FILE "./CPackSourceConfig.cmake")
SET(CPACK_SOURCE_STRIP_FILES "")
SET(CPACK_SYSTEM_NAME "Linux-i686")
SET(CPACK_TOPLEVEL_TAG "Linux-i686")
SET(CPACK_SOURCE_PACKAGE_FILE_NAME "libodsstream-${LIBODSSTREAM_VERSION}")


SET(CPACK_SOURCE_IGNORE_FILES 
  ".*\\\\.tar\\\\.gz"
  "moc_.*cxx"
  "\\\\.#.*"
  ".*\\\\.aux"
  ".*\\\\.bbl"
  ".*\\\\.blg"
  ".*\\\\.log"
  ".*\\\\.out"
  ".*\\\\.toc"
  "/devel_archives/"
  "/doc\\\\/html/"
  "/doc\\\\/latex/"
  "Makefile"
  "install_manifest.txt"
  "CMakeCache.txt"
  "CPackConfig.cmake"
  "CPackSourceConfig.cmake"
  "/CMakeFiles/"
  "/_CPack_Packages/"
  "/Debug/"
  "/Release/"
  "/tests/"
  "/\\\\.externalToolBuilders/"
  "/\\\\.git/"
  "/\\\\.kdev4/"
  "/\\\\.settings/"
  "Makefile"
  "\\\\.gitignore"
  "\\\\.cdtbuild"
  "\\\\.cdtproject"
  "\\\\.project"
  "\\\\.cproject"
  "/win32/"
  "/build/"
  "/buildmingw/"
  "libodsstream.so"
  "OpenDocument-v1.0-os.pdf"
  )
# to create a TGZ archive of the  source code type shell command
# cpack -G TGZ --config CPackSourceConfig.cmake 

# dpkg-buildpackage -rfakeroot -k7BEF3B25

#.dput.cf
#[olivier-langella]
#fqdn = ppa.launchpad.net
#method = ftp
#incoming = ~olivier-langella/ubuntu/
#login = olivier-langella
#allow_unsigned_uploads = 0
#
#  debuild -S -sa
# dput -f olivier-langella *changes


#MESSAGE("configuring file ${LIBODSSTREAM_SOURCE_DIR}/src/config.h.cmake")

#configure_file (${LIBODSSTREAM_SOURCE_DIR}/src/config.h.cmake ${LIBODSSTREAM_SOURCE_DIR}/src/config.h)



SET(CPACK_PACKAGE_EXECUTABLES "libodsstream" "libodsstream")


# for debian package :
SET(CPACK_DEBIAN_PACKAGE_MAINTAINER "Olivier Langella <Olivier.Langella@moulon.inra.fr>")
SET(DEBIAN_PACKAGE_BUILDS_DEPENDS "Olivier Langella <Olivier.Langella@moulon.inra.fr>")


INCLUDE(CPack)


add_subdirectory (src)

add_subdirectory (doc)

add_custom_target(targz
	cpack -G TGZ --config CPackSourceConfig.cmake && tar xvfz libodsstream-${LIBODSSTREAM_VERSION}.tar.gz
	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
	COMMENT "Creating .tar.gz" VERBATIM
)


add_custom_target(deb
	cd libodsstream-${LIBODSSTREAM_VERSION} && dpkg-buildpackage 
	DEPENDS targz
	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
	COMMENT "Creating Debian package" VERBATIM
)

=== doc/CMakeLists.txt ===

# add a target to generate API documentation with Doxygen
find_package(Doxygen)
if(DOXYGEN_FOUND)
configure_file(${CMAKE_SOURCE_DIR}/src/doxyfile.cmake ${CMAKE_CURRENT_BINARY_DIR}/doxyfile @ONLY)
add_custom_target(doc
${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/doxyfile
WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/src
COMMENT "Generating API documentation with Doxygen" VERBATIM
)
endif(DOXYGEN_FOUND)

=== src/CMakeLists.txt ===

#find zlib
FIND_PACKAGE(ZLIB REQUIRED)
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/modules)
FIND_PACKAGE(QuaZip REQUIRED)

INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${QUAZIP_INCLUDE_DIRS})
INCLUDE_DIRECTORIES("/usr/include/libodsstream")

# this command finds Qt4 libraries and sets all required variables
# note that it's Qt4, not QT4 or qt4

SET (QT_USE_QTXML true)
SET (QT_USE_QTXMLPATTERNS true)
FIND_PACKAGE( Qt4 REQUIRED )

# (QT_USE_FILE is a variable defined by FIND_PACKAGE( Qt4 ) that contains a path to CMake script)
INCLUDE( ${QT_USE_FILE} )



SET(libodsstream_SRC_LIB reader/odscell.cpp odsexception.h ./saxreader/saxhandlercontentxml.cpp ./odsdocreader.cpp structure/stylesxml.cpp structure/contentxml.cpp structure/metaxml.cpp structure/manifestxml.cpp
  ./odsdocwriter.cpp
)


ADD_LIBRARY(odsstream SHARED ${libodsstream_SRC_LIB})
ADD_LIBRARY(odsstream_static STATIC ${libodsstream_SRC_LIB})
set_target_properties(odsstream_static PROPERTIES OUTPUT_NAME odsstream)

ADD_EXECUTABLE(test_ods main.cpp)
TARGET_LINK_LIBRARIES(test_ods ${QT_LIBRARIES} ${QUAZIP_LIBRARIES} "odsstream")

INSTALL(TARGETS odsstream LIBRARY DESTINATION lib/libodsstream)
INSTALL(TARGETS odsstream_static ARCHIVE DESTINATION lib/libodsstream)

FILE(GLOB files "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
INSTALL(FILES ${files} DESTINATION include/libodsstream)

=== debian/changelog ===
libodsstream (0.0.1-1) wheezy; urgency=low

  * first debian package

 -- Olivier Langella <olivier.langella@moulon.inra.fr>  Sat, 6 Jul 2013 06:18:51 +0200

=== debian/control ===
Source: libodsstream
Maintainer: Olivier Langella <olivier.langella@moulon.inra.fr>
Homepage: http://pappso.inra.fr/bioinfo
Section: libs
Priority: optional
Build-Depends: debhelper (>= 9),
               libquazip0-dev
Standards-Version: 3.9.4

Package: libodsstream0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: C++ library to read or write ODS files
 libodsstream provides a simple way to read and write Open 
 Document Spreadsheet files using streams only to be memory efficient.

Package: libodsstream-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libodsstream0 (= ${binary:Version}),
         ${misc:Depends},
         libquazip-dev
Description: C++ library to read or write ODS files
 libodsstream provides a simple way to read and write Open 
 Document Spreadsheet files using streams only to be memory efficient.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DESTDIR=$(CURDIR)/debian/tmp

#%:
#	dh $@ --buildsystem=cmake --parallel

configure: configure-stamp
configure-stamp:
	cmake -DCMAKE_INSTALL_PREFIX=/usr .
	dh_testdir
	# Add here commands to configure the package.

	touch configure-stamp


build: build-stamp

build-stamp: configure-stamp 
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)
	$(MAKE) doc
	#docbook-to-man debian/beads.sgml > beads.1

	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp CMakeCache.txt

	# Add here commands to clean up after the build process.
	-$(MAKE) clean

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	$(MAKE) DESTDIR=$(DESTDIR) install


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
	dh_installexamples
	dh_install --sourcedir=$(DESTDIR) --list-missing
#	dh_install
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## libodsstream 0.4.8-1

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,18 +9,25 @@
 PROJECT(libodsstream CXX C)
 
 
+IF(NOT USEQT4)
+  IF(NOT USEQT5)
+    SET (USEQT4 1)
+  ENDIF(NOT USEQT5)
+ENDIF(NOT USEQT4)
+
 # Project version
 # 
 
 SET (LIBODSSTREAM_MAJOR_VERSION 0)
-SET (LIBODSSTREAM_MINOR_VERSION 0)
-SET (LIBODSSTREAM_PATCH_LEVEL   1)
+SET (LIBODSSTREAM_MINOR_VERSION 4)
+SET (LIBODSSTREAM_PATCH_LEVEL   8)
 SET (LIBODSSTREAM_VERSION
   "${LIBODSSTREAM_MAJOR_VERSION}.${LIBODSSTREAM_MINOR_VERSION}.${LIBODSSTREAM_PATCH_LEVEL}")
 SET (LIBODSSTREAM_LIB_NAME "libodsstream")
 SET (LIBODSSTREAM_LIB_VERSION ${LIBODSSTREAM_VERSION})
 SET (LIBODSSTREAM_LIB_SOVERSION ${LIBODSSTREAM_MAJOR_VERSION})
 
+SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
 
 if (NOT CMAKE_INSTALL_PREFIX)
   SET (CMAKE_INSTALL_PREFIX /usr/local)
@@ -128,6 +135,20 @@
 # dput -f olivier-langella *changes
 
 
+#dch -Djessie "message"
+#cmake ..
+#make deb
+# scp libodsstream* proteus:/var/www/apt/incoming
+# reprepro -Vb /var/www/apt processincoming default
+
+
+#dpkg-deb -x libodsstream-qt4_0.3.0-3_amd64.deb libodsstream-qt4_0.3.0-3
+#dpkg-gensymbols -v0 -plibodsstream-qt4 -Plibodsstream-qt4_0.3.0-3 -Osymbols
+#cp symbols ../debian/libodsstream-qt4.symbols
+#dpkg-deb -x libodsstream-qt5_0.3.0-3_amd64.deb libodsstream-qt5_0.3.0-3
+#dpkg-gensymbols -v0 -plibodsstream-qt5 -Plibodsstream-qt5_0.3.0-3 -Osymbols
+#cp symbols ../debian/libodsstream-qt5.symbols
+
 #MESSAGE("configuring file ${LIBODSSTREAM_SOURCE_DIR}/src/config.h.cmake")
 
 #configure_file (${LIBODSSTREAM_SOURCE_DIR}/src/config.h.cmake ${LIBODSSTREAM_SOURCE_DIR}/src/config.h)
@@ -162,3 +183,39 @@
 	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
 	COMMENT "Creating Debian package" VERBATIM
 )
+
+
+	
+SET(DCH_VERSION "1")
+
+add_custom_target(symbolsqt5
+	dpkg-deb -x libodsstream-qt5_${LIBODSSTREAM_VERSION}-${DCH_VERSION}_amd64.deb libodsstream-qt5-untar && dpkg-gensymbols -v0 -plibodsstream-qt5 -Plibodsstream-qt5-untar -Osymbols && cp symbols ../debian/libodsstream-qt5.symbols
+	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
+	COMMENT "symbolsqt5 " VERBATIM
+)
+	
+add_custom_target(symbolsqt4
+	dpkg-deb -x libodsstream-qt4_${LIBODSSTREAM_VERSION}-${DCH_VERSION}_amd64.deb libodsstream-qt4-untar && dpkg-gensymbols -v0 -plibodsstream-qt4 -Plibodsstream-qt4-untar -Osymbols && cp symbols ../debian/libodsstream-qt4.symbols
+	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
+	COMMENT "symbolsqt4" VERBATIM
+)
+	
+add_custom_target(symbols
+	DEPENDS symbolsqt4 symbolsqt5
+	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
+	COMMENT "symbols generation" VERBATIM
+)
+
+
+IF(NOT CMAKE_BUILD_TYPE MATCHES "Release")
+  ENABLE_TESTING()
+  INCLUDE(CTest)
+  IF (BUILD_TESTING)
+    ADD_SUBDIRECTORY(test)
+  ENDIF(BUILD_TESTING)
+ENDIF(NOT CMAKE_BUILD_TYPE MATCHES "Release" )
+
+
+
+# Install cmake module
+INSTALL(FILES modules/FindOdsstream.cmake DESTINATION share/cmake-3.0/Modules)

=== src/CMakeLists.txt ===

#find zlib
FIND_PACKAGE(ZLIB REQUIRED)
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/modules)
FIND_PACKAGE(QuaZip REQUIRED)

INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
#INCLUDE_DIRECTORIES(${QUAZIP_INCLUDE_DIRS})


#SET (QT_USE_QTXMLPATTERNS true)



SET(CPP_FILES 
  odsstream/reader/odscell.cpp
  odsstream/odsexception.h 
  odsstream/saxreader/saxhandlercontentxml.cpp 
  odsstream/odsdocreader.cpp
  odsstream/structure/stylesxml.cpp
  odsstream/structure/contentxml.cpp
  odsstream/structure/metaxml.cpp
  odsstream/structure/manifestxml.cpp
  odsstream/odsdocwriter.cpp
  odsstream/tsvdirectorywriter.cpp
  odsstream/tsvoutputstream.cpp
  odsstream/odstablecellstyle.cpp
  odsstream/odstablecellstyleref.cpp
)



SET(ODS2CSV_CPP_FILES 
  ods2csv.cpp
)

SET(ODS2CSV_MOC_HDRS
  ods2csv.h
)


configure_file (${CMAKE_SOURCE_DIR}/src/config.h.cmake ${CMAKE_SOURCE_DIR}/src/config.h)

IF (USEQT5)
  #qt5-default qtbase5-dev
  FIND_PACKAGE( Qt5Xml REQUIRED )
  FIND_PACKAGE( Qt5Gui REQUIRED )

  # Build the static lib
  ADD_LIBRARY(odsstream-static-qt5 STATIC ${CPP_FILES})
  target_include_directories (odsstream-static-qt5 PUBLIC ${Qt5Xml_INCLUDES}  ${Qt5Gui_INCLUDES})
    
    SET_TARGET_PROPERTIES(odsstream-static-qt5
      PROPERTIES OUTPUT_NAME odsstream-qt5
      CLEAN_DIRECT_OUTPUT 1
      CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS} ${Qt5Xml_EXECUTABLE_COMPILE_FLAGS} ${Qt5Gui_EXECUTABLE_COMPILE_FLAGS}"
    )
  TARGET_LINK_LIBRARIES(odsstream-static-qt5 ${LIBS} ${Qt5Xml_LIBRARIES}  ${QUAZIP_QT5_LIBRARIES} ${Qt5Gui_LIBRARIES})

  # Build the shared lib
  ADD_LIBRARY(odsstream-shared-qt5 SHARED ${CPP_FILES})
  target_include_directories (odsstream-shared-qt5 PUBLIC ${Qt5Xml_INCLUDES} ${Qt5Gui_INCLUDES})
  SET_TARGET_PROPERTIES(odsstream-shared-qt5
    PROPERTIES OUTPUT_NAME odsstream-qt5
    CLEAN_DIRECT_OUTPUT 1
    VERSION ${LIBODSSTREAM_VERSION}
    SOVERSION ${LIBODSSTREAM_MAJOR_VERSION}
    CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS} ${Qt5Xml_EXECUTABLE_COMPILE_FLAGS} ${Qt5Gui_EXECUTABLE_COMPILE_FLAGS}"
    )
  TARGET_LINK_LIBRARIES(odsstream-shared-qt5 ${LIBS} ${Qt5Xml_LIBRARIES}  ${QUAZIP_QT5_LIBRARIES} ${Qt5Gui_LIBRARIES})

  # Install libs
  INSTALL(TARGETS odsstream-static-qt5 odsstream-shared-qt5 DESTINATION lib${LIB_SUFFIX})
  
 SET (PAPPSOMSPP_INCLUDE_DIR "${PAPPSOMSPP_DIR}/src")
# SET (PAPPSOMSPP_QT5_LIBRARY "${PAPPSOMSPP_DIR}/build/src/libpappsomspp-qt5.so")
# SET (PAPPSOMSPP_QT4_LIBRARY "${PAPPSOMSPP_DIR}/build/src/libpappsomspp-qt4.so")
  
  QT5_WRAP_CPP( ODS2CSV_MOC_SRCS ${ODS2CSV_MOC_HDRS} )
  ADD_EXECUTABLE(ods2csv ${ODS2CSV_CPP_FILES} ${ODS2CSV_MOC_SRCS})
  target_include_directories (ods2csv PUBLIC ${Qt5Core_INCLUDES} ${Qt5Gui_INCLUDES} "${CMAKE_SOURCE_DIR}/src")
  SET_TARGET_PROPERTIES(ods2csv
      PROPERTIES OUTPUT_NAME ods2tsv
      CLEAN_DIRECT_OUTPUT 1
      CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS} ${Qt5Gui_EXECUTABLE_COMPILE_FLAGS}"
    )
  TARGET_LINK_LIBRARIES(ods2csv odsstream-shared-qt5 ${Qt5Core_LIBRARIES} ${Qt5Gui_LIBRARIES})

  INSTALL(PROGRAMS ${CMAKE_BINARY_DIR}/src/ods2tsv DESTINATION bin)

ENDIF(USEQT5)

IF (USEQT4)
  #qt5-default qtbase5-dev
  FIND_PACKAGE( Qt4 COMPONENTS QTCORE QTXML QTGUI REQUIRED )
  
  MESSAGE ("QT_DEFINITIONS ${QT_DEFINITIONS}" )
  MESSAGE ("QT_INCLUDE_DIR ${QT_INCLUDE_DIR}" )
  MESSAGE ("QT_QTCORE_INCLUDE_DIR ${QT_QTCORE_INCLUDE_DIR}" )
  MESSAGE ("QT_QTXML_INCLUDE_DIR ${QT_QTXML_INCLUDE_DIR}" )
  

  # Build the static lib
  ADD_LIBRARY(odsstream-static-qt4 STATIC ${CPP_FILES})
  target_include_directories (odsstream-static-qt4 PUBLIC ${QUAZIP_INCLUDE_DIR} ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTXML_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR})
  IF (MINGW)
    SET_TARGET_PROPERTIES(odsstream-static-qt4
      PROPERTIES OUTPUT_NAME odsstream-qt4
      CLEAN_DIRECT_OUTPUT 1
      )
  ELSE (MINGW)
    SET_TARGET_PROPERTIES(odsstream-static-qt4
      PROPERTIES OUTPUT_NAME odsstream-qt4
      CLEAN_DIRECT_OUTPUT 1
      COMPILE_DEFINITIONS "${QT_DEFINITIONS}"
      #INCLUDE_DIRECTORIES "${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR}"
      )
  ENDIF (MINGW)
  TARGET_LINK_LIBRARIES(odsstream-static-qt4 ${LIBS} ${QT_QTCORE_LIBRARY} ${QT_QTXML_LIBRARY}  ${QUAZIP_QT4_LIBRARIES} ${QT_QTGUI_LIBRARY})

  # Build the shared lib
  ADD_LIBRARY(odsstream-shared-qt4 SHARED ${CPP_FILES})
  target_include_directories (odsstream-shared-qt4 PUBLIC ${QUAZIP_INCLUDE_DIR} ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTXML_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR})
  IF(MINGW)
    SET_TARGET_PROPERTIES(odsstream-shared-qt4
      PROPERTIES OUTPUT_NAME odsstream-qt4
      CLEAN_DIRECT_OUTPUT 1
      VERSION ${LIBODSSTREAM_VERSION}
      SOVERSION ${LIBODSSTREAM_MAJOR_VERSION}
      #INCLUDE_DIRECTORIES "${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR}"
      )
  ELSE (MINGW)
    SET_TARGET_PROPERTIES(odsstream-shared-qt4
      PROPERTIES OUTPUT_NAME odsstream-qt4
      CLEAN_DIRECT_OUTPUT 1
      VERSION ${LIBODSSTREAM_VERSION}
      SOVERSION ${LIBODSSTREAM_MAJOR_VERSION}
      COMPILE_DEFINITIONS "${QT_DEFINITIONS}"
      #INCLUDE_DIRECTORIES "${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR}"
      )
  ENDIF (MINGW)
  TARGET_LINK_LIBRARIES(odsstream-shared-qt4 ${LIBS} ${QT_QTCORE_LIBRARY} ${QT_QTXML_LIBRARY}  ${QUAZIP_QT4_LIBRARIES} ${QT_QTGUI_LIBRARY})

  # Install libs
  INSTALL(TARGETS odsstream-static-qt4 odsstream-shared-qt4 DESTINATION lib${LIB_SUFFIX})

ENDIF(USEQT4)



# Install headers
INSTALL(DIRECTORY odsstream/ DESTINATION include/odsstream FILES_MATCHING PATTERN "*.h")

=== test/CMakeLists.txt ===
# CMake script for PAPPSOms++ library
# Author: Olivier Langella
# Created: 03/03/2015 from the CMakeLists file of the Bio++ project

#CTEST_OUTPUT_ON_FAILURE=TRUE make test
#make test ARGS="-V"

MACRO(TEST_FIND_LIBRARY OUTPUT_LIBS lib_name include_to_find)
  #start:
  FIND_PATH(${lib_name}_INCLUDE_DIR ${include_to_find})

  SET(${lib_name}_NAMES ${lib_name} ${lib_name}.lib ${lib_name}.dll)
  FIND_LIBRARY(${lib_name}_LIBRARY NAMES ${${lib_name}_NAMES})
  IF(${lib_name}_LIBRARY)
    MESSAGE("-- Library ${lib_name} found here:")
    MESSAGE("   includes: ${${lib_name}_INCLUDE_DIR}")
    MESSAGE("   dynamic libraries: ${${lib_name}_LIBRARY}")
    MESSAGE(WARNING "Library ${lib_name} is already installed in the system tree. Test will be built against it. This may lead to unexpected results. You may want to do 'make install' before 'make test', or remove the installed version.")
  ELSE()
    MESSAGE("${lib_name}_LIBRARY -L../src -l${lib_name}")
    MESSAGE("${lib_name}_INCLUDE_DIR ../src/")
    MESSAGE("${LIBS}")
    SET(${lib_name}_LIBRARY "-L../src -l${lib_name}")
    SET(${lib_name}_INCLUDE_DIR "../src/")
  ENDIF()
  INCLUDE_DIRECTORIES(${${lib_name}_INCLUDE_DIR})
  SET(${OUTPUT_LIBS} ${${OUTPUT_LIBS}} ${${lib_name}_LIBRARY})
ENDMACRO(TEST_FIND_LIBRARY)


# File list
SET(CPP_TEST_FILES
  
  )
  

IF (USEQT5)
  IF (USEQT4)
     SET (USEQT5 0)
     SET (USEQT4 1)
  ENDIF(USEQT4)
ENDIF(USEQT5)

IF (USEQT5)
  #Find the bpp-core library library:
  TEST_FIND_LIBRARY(LIBS odsstream-qt5 odsstream/odsdocreader.h)

  FIND_PACKAGE( Qt5Core REQUIRED )
  FIND_PACKAGE( Qt5Xml REQUIRED )
  FIND_PACKAGE( Qt5Gui REQUIRED )
  INCLUDE_DIRECTORIES(${Qt5Core_INCLUDES} ${Qt5Xml_INCLUDES} ${Qt5Gui_INCLUDES})
  SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS} ${Qt5Xml_EXECUTABLE_COMPILE_FLAGS} ${Qt5Gui_EXECUTABLE_COMPILE_FLAGS}")
 
  set(QTLIBS ${Qt5Core_LIBRARIES} ${Qt5Xml_LIBRARIES} ${Qt5Gui_LIBRARIES})
ENDIF(USEQT5)

IF (USEQT4)
  #Find the bpp-core library library:
  TEST_FIND_LIBRARY(LIBS odsstream-qt4 odsstream/odsdocreader.h)

  FIND_PACKAGE( Qt4 COMPONENTS QTCORE QTXML QTGUI REQUIRED )
  
  INCLUDE( ${QT_USE_FILE} )
  set(QTLIBS "${QT_LIBRARIES}")
ENDIF(USEQT4)

ADD_EXECUTABLE(test_ods test_ods.cpp)
TARGET_LINK_LIBRARIES(test_ods ${LIBS} ${QTLIBS})
ADD_TEST(test_ods "test_ods")


ADD_EXECUTABLE(test_tsv test_tsv.cpp)
TARGET_LINK_LIBRARIES(test_tsv ${LIBS} ${QTLIBS})
ADD_TEST(test_tsv "test_tsv")


IF(UNIX)
  SET_PROPERTY(TEST test_ods test_tsv ${TEST_LIST} PROPERTY ENVIRONMENT "LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH}:../src")
ENDIF()

IF(WIN32)
  SET(ENV{PATH} "$ENV{PATH};..\\src")
ENDIF()

=== debian/changelog ===
libodsstream (0.4.8-1) jessie; urgency=medium

  * new cell format for percentage

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Tue, 23 May 2017 22:01:00 +0200

libodsstream (0.4.7-2) jessie; urgency=medium

  * ends tsv files with EOL 

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Tue, 17 Jan 2017 15:49:21 +0100

libodsstream (0.4.7-1) jessie; urgency=medium

  * ods2tsv package

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Fri, 13 Jan 2017 16:15:20 +0100

libodsstream (0.4.6-1) jessie; urgency=medium

  * tabulation bug fixed, thanks to T. Balliau

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Mon, 12 Dec 2016 16:14:39 +0100

libodsstream (0.4.4-1) jessie; urgency=medium

  * write annotations in cells

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Fri, 19 Aug 2016 15:29:35 +0200

libodsstream (0.4.3-1) jessie; urgency=medium

  * better flush and close

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Thu, 21 Apr 2016 19:12:02 +0200

libodsstream (0.4.2-1) jessie; urgency=medium

  * virtual destructor for calc writer interface

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Tue, 19 Apr 2016 22:09:16 +0200

libodsstream (0.4.1-1) jessie; urgency=medium

  * API to write ODS directly in file

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Tue, 12 Apr 2016 21:07:25 +0200

libodsstream (0.4.0-1) jessie; urgency=medium

  * switch licence from GPLv3 to LGPLv3

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Fri, 16 Oct 2015 14:19:06 +0200

libodsstream (0.3.0-3) jessie; urgency=medium

  * SOVERSION number fixed

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Thu, 20 Aug 2015 21:36:18 +0200

libodsstream (0.3.0-2) jessie; urgency=medium

  * library informations added in debian package (symbols, shlibs)

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Thu, 20 Aug 2015 21:23:15 +0200

libodsstream (0.3.0-1) jessie; urgency=medium

  * first cell style support API

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Mon, 17 Aug 2015 17:04:04 +0200

libodsstream (0.2.1-1) jessie; urgency=medium

  * TSV output stream

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Mon, 13 Jul 2015 08:57:58 +0200

libodsstream (0.2.0-2) jessie; urgency=medium

  * make calc writer interface public

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Wed, 24 Jun 2015 22:28:32 +0200

libodsstream (0.2.0-1) jessie; urgency=medium

  * write tsv directory

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Wed, 24 Jun 2015 19:51:01 +0200

libodsstream (0.1.3-1) jessie; urgency=medium

  * write empty cell

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Tue, 16 Jun 2015 21:00:21 +0200

libodsstream (0.1.2-2) jessie; urgency=medium

  * endif bug fixed

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Fri, 12 Jun 2015 10:37:27 +0200

libodsstream (0.1.2-1) jessie; urgency=medium

  * double compilation qt4 and qt5

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Fri, 12 Jun 2015 10:16:02 +0200

libodsstream (0.1.1-2) jessie; urgency=medium

  * writeLine bug fixed

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Wed, 10 Jun 2015 13:27:22 +0200

libodsstream (0.1.1-1) jessie; urgency=medium

  * new version using Qt5

 -- Olivier Langella <olivier.langella@moulon.inra.fr>  Wed, 10 Jun 2015 07:56:44 +0200

=== debian/control ===
Source: libodsstream
Maintainer: Olivier Langella <Olivier.Langella@moulon.inra.fr>
Homepage: http://pappso.inra.fr/bioinfo
Section: libs
Priority: optional
Build-Depends: debhelper (>= 9), libqt4-dev (>= 4.6.3), qt5-default, libquazip-qt5-dev, qtbase5-dev
Standards-Version: 3.9.4

Package: libodsstream-qt4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: C++ library to read or write ODS files
 libodsstream provides a simple way to read and write Open 
 Document Spreadsheet files using streams only to be memory efficient.

Package: libodsstream-qt5
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: C++ library to read or write ODS files
 libodsstream provides a simple way to read and write Open 
 Document Spreadsheet files using streams only to be memory efficient.

Package: libodsstream-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libodsstream-qt4 (= ${binary:Version}), libodsstream-qt5 (= ${binary:Version}),
         ${misc:Depends},
         libquazip-dev
Description: C++ library to read or write ODS files
 libodsstream provides a simple way to read and write Open 
 Document Spreadsheet files using streams only to be memory efficient.

Package: libodsstream-doc
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}
Description: doxygen documentation of the ODSstream library
 libodsstream provides a simple way to read and write Open 
 Document Spreadsheet files using streams only to be memory efficient.
 
Package: ods2tsv
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, libodsstream-qt5 (= ${binary:Version}),
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ODS to TSV file converter
 uses libodsstream to convert Open Document Spreadsheet files to TSV format.

=== debian/rules ===
--- 
+++ 
@@ -8,6 +8,7 @@
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
+export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
 export DESTDIR=$(CURDIR)/debian/tmp
 
@@ -16,7 +17,7 @@
 
 configure: configure-stamp
 configure-stamp:
-	cmake -DCMAKE_INSTALL_PREFIX=/usr .
+	cmake -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" -DCMAKE_INSTALL_PREFIX=/usr -DUSEQT4=1 -DUSEQT5=1 -DCMAKE_BUILD_TYPE=Release .
 	dh_testdir
 	# Add here commands to configure the package.
 
@@ -77,6 +78,7 @@
 	dh_gencontrol
 	dh_md5sums
 	dh_builddeb
+	dh_makeshlibs
 
 binary: binary-indep binary-arch
 .PHONY: build clean binary-indep binary-arch binary install configure

## libodsstream 0.4.13

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 
 IF(NOT USEQT4)
   IF(NOT USEQT5)
-    SET (USEQT4 1)
+    SET (USEQT5 1)
   ENDIF(NOT USEQT5)
 ENDIF(NOT USEQT4)
 
@@ -20,14 +20,14 @@
 
 SET (LIBODSSTREAM_MAJOR_VERSION 0)
 SET (LIBODSSTREAM_MINOR_VERSION 4)
-SET (LIBODSSTREAM_PATCH_LEVEL   8)
+SET (LIBODSSTREAM_PATCH_LEVEL   13)
 SET (LIBODSSTREAM_VERSION
   "${LIBODSSTREAM_MAJOR_VERSION}.${LIBODSSTREAM_MINOR_VERSION}.${LIBODSSTREAM_PATCH_LEVEL}")
 SET (LIBODSSTREAM_LIB_NAME "libodsstream")
 SET (LIBODSSTREAM_LIB_VERSION ${LIBODSSTREAM_VERSION})
 SET (LIBODSSTREAM_LIB_SOVERSION ${LIBODSSTREAM_MAJOR_VERSION})
 
-SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
+SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
 
 if (NOT CMAKE_INSTALL_PREFIX)
   SET (CMAKE_INSTALL_PREFIX /usr/local)
@@ -47,6 +47,7 @@
 
 IF(CMAKE_BUILD_TYPE MATCHES "Debug")
   MESSAGE("compiling as debug version")
+  set (MAKE_TEST 1)
 ENDIF( CMAKE_BUILD_TYPE MATCHES "Debug" )
 
 IF(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
@@ -113,8 +114,14 @@
   "\\\\.project"
   "\\\\.cproject"
   "/win32/"
+  "/win64/"
   "/build/"
+  "/buildwin64/"
+  "/cbuild/"
+  "/bin/"
   "/buildmingw/"
+  "test\\\\.ods"
+  "buildwin32.cmd"
   "libodsstream.so"
   "OpenDocument-v1.0-os.pdf"
   )
@@ -135,7 +142,7 @@
 # dput -f olivier-langella *changes
 
 
-#dch -Djessie "message"
+#dch -Dstretch "message"
 #cmake ..
 #make deb
 # scp libodsstream* proteus:/var/www/apt/incoming
@@ -159,12 +166,11 @@
 
 
 # for debian package :
-SET(CPACK_DEBIAN_PACKAGE_MAINTAINER "Olivier Langella <Olivier.Langella@moulon.inra.fr>")
-SET(DEBIAN_PACKAGE_BUILDS_DEPENDS "Olivier Langella <Olivier.Langella@moulon.inra.fr>")
+SET(CPACK_DEBIAN_PACKAGE_MAINTAINER "Olivier Langella <olivier.langella@u-psud.fr>")
+SET(DEBIAN_PACKAGE_BUILDS_DEPENDS "Olivier Langella <olivier.langella@u-psud.fr>")
 
 
 INCLUDE(CPack)
-
 
 add_subdirectory (src)
 
@@ -185,37 +191,18 @@
 )
 
 
-	
-SET(DCH_VERSION "1")
-
-add_custom_target(symbolsqt5
-	dpkg-deb -x libodsstream-qt5_${LIBODSSTREAM_VERSION}-${DCH_VERSION}_amd64.deb libodsstream-qt5-untar && dpkg-gensymbols -v0 -plibodsstream-qt5 -Plibodsstream-qt5-untar -Osymbols && cp symbols ../debian/libodsstream-qt5.symbols
-	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
-	COMMENT "symbolsqt5 " VERBATIM
-)
-	
-add_custom_target(symbolsqt4
-	dpkg-deb -x libodsstream-qt4_${LIBODSSTREAM_VERSION}-${DCH_VERSION}_amd64.deb libodsstream-qt4-untar && dpkg-gensymbols -v0 -plibodsstream-qt4 -Plibodsstream-qt4-untar -Osymbols && cp symbols ../debian/libodsstream-qt4.symbols
-	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
-	COMMENT "symbolsqt4" VERBATIM
-)
-	
-add_custom_target(symbols
-	DEPENDS symbolsqt4 symbolsqt5
-	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
-	COMMENT "symbols generation" VERBATIM
-)
-
-
-IF(NOT CMAKE_BUILD_TYPE MATCHES "Release")
+IF(MAKE_TEST)
   ENABLE_TESTING()
   INCLUDE(CTest)
   IF (BUILD_TESTING)
     ADD_SUBDIRECTORY(test)
   ENDIF(BUILD_TESTING)
-ENDIF(NOT CMAKE_BUILD_TYPE MATCHES "Release" )
+ENDIF(MAKE_TEST)
 
 
 
 # Install cmake module
-INSTALL(FILES modules/FindOdsstream.cmake DESTINATION share/cmake-3.0/Modules)
+INSTALL(FILES modules/FindOdsstream.cmake DESTINATION share/cmake/Modules)
+# Install cmake config
+configure_file (${CMAKE_SOURCE_DIR}/modules/OdsstreamConfig.cmake ${CMAKE_SOURCE_DIR}/OdsstreamConfig.cmake)
+INSTALL(FILES ${CMAKE_SOURCE_DIR}/OdsstreamConfig.cmake DESTINATION lib${LIB_SUFFIX}/cmake/odsstream)

=== doc/CMakeLists.txt ===

# add a target to generate API documentation with Doxygen
find_package(Doxygen)
if(DOXYGEN_FOUND)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
add_custom_target(doc
${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/src
COMMENT "Generating API documentation with Doxygen" VERBATIM
)
INSTALL(DIRECTORY  ${CMAKE_CURRENT_BINARY_DIR}/html DESTINATION share/doc/libodsstream)

endif(DOXYGEN_FOUND)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -42,35 +42,38 @@
 configure_file (${CMAKE_SOURCE_DIR}/src/config.h.cmake ${CMAKE_SOURCE_DIR}/src/config.h)
 
 IF (USEQT5)
+    MESSAGE ("LIBODSSTREAM_LIB_SOVERSION: ${LIBODSSTREAM_LIB_SOVERSION}")
   #qt5-default qtbase5-dev
+  FIND_PACKAGE( Qt5Core REQUIRED )
   FIND_PACKAGE( Qt5Xml REQUIRED )
   FIND_PACKAGE( Qt5Gui REQUIRED )
 
   # Build the static lib
   ADD_LIBRARY(odsstream-static-qt5 STATIC ${CPP_FILES})
-  target_include_directories (odsstream-static-qt5 PUBLIC ${Qt5Xml_INCLUDES}  ${Qt5Gui_INCLUDES})
+  target_include_directories (odsstream-static-qt5 PUBLIC ${Qt5Xml_INCLUDES} ${Qt5Core_INCLUDES} ${Qt5Gui_INCLUDES})
     
     SET_TARGET_PROPERTIES(odsstream-static-qt5
       PROPERTIES OUTPUT_NAME odsstream-qt5
       CLEAN_DIRECT_OUTPUT 1
       CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS} ${Qt5Xml_EXECUTABLE_COMPILE_FLAGS} ${Qt5Gui_EXECUTABLE_COMPILE_FLAGS}"
     )
-  TARGET_LINK_LIBRARIES(odsstream-static-qt5 ${LIBS} ${Qt5Xml_LIBRARIES}  ${QUAZIP_QT5_LIBRARIES} ${Qt5Gui_LIBRARIES})
+  TARGET_LINK_LIBRARIES(odsstream-static-qt5 ${Qt5Xml_LIBRARIES} ${Qt5Gui_LIBRARIES}  ${QUAZIP_QT5_LIBRARIES} ${Qt5Core_LIBRARIES})
 
   # Build the shared lib
   ADD_LIBRARY(odsstream-shared-qt5 SHARED ${CPP_FILES})
-  target_include_directories (odsstream-shared-qt5 PUBLIC ${Qt5Xml_INCLUDES} ${Qt5Gui_INCLUDES})
-  SET_TARGET_PROPERTIES(odsstream-shared-qt5
-    PROPERTIES OUTPUT_NAME odsstream-qt5
+  target_include_directories (odsstream-shared-qt5 PUBLIC ${Qt5Xml_INCLUDES} ${Qt5Core_INCLUDES} ${Qt5Gui_INCLUDES})
+  SET_TARGET_PROPERTIES(odsstream-shared-qt5 PROPERTIES 
+    OUTPUT_NAME odsstream-qt5
+    VERSION ${LIBODSSTREAM_LIB_VERSION}
+    SOVERSION ${LIBODSSTREAM_LIB_SOVERSION}
+    CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS} ${Qt5Xml_EXECUTABLE_COMPILE_FLAGS} ${Qt5Gui_EXECUTABLE_COMPILE_FLAGS}"
     CLEAN_DIRECT_OUTPUT 1
-    VERSION ${LIBODSSTREAM_VERSION}
-    SOVERSION ${LIBODSSTREAM_MAJOR_VERSION}
-    CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS} ${Qt5Xml_EXECUTABLE_COMPILE_FLAGS} ${Qt5Gui_EXECUTABLE_COMPILE_FLAGS}"
     )
-  TARGET_LINK_LIBRARIES(odsstream-shared-qt5 ${LIBS} ${Qt5Xml_LIBRARIES}  ${QUAZIP_QT5_LIBRARIES} ${Qt5Gui_LIBRARIES})
+  TARGET_LINK_LIBRARIES(odsstream-shared-qt5 PUBLIC ${Qt5Xml_LIBRARIES} ${Qt5Gui_LIBRARIES} ${QUAZIP_QT5_LIBRARIES} )
 
   # Install libs
-  INSTALL(TARGETS odsstream-static-qt5 odsstream-shared-qt5 DESTINATION lib${LIB_SUFFIX})
+  INSTALL(TARGETS odsstream-shared-qt5 LIBRARY DESTINATION lib${LIB_SUFFIX})
+  INSTALL(TARGETS odsstream-static-qt5 DESTINATION lib${LIB_SUFFIX})
   
  SET (PAPPSOMSPP_INCLUDE_DIR "${PAPPSOMSPP_DIR}/src")
 # SET (PAPPSOMSPP_QT5_LIBRARY "${PAPPSOMSPP_DIR}/build/src/libpappsomspp-qt5.so")
@@ -78,13 +81,13 @@
   
   QT5_WRAP_CPP( ODS2CSV_MOC_SRCS ${ODS2CSV_MOC_HDRS} )
   ADD_EXECUTABLE(ods2csv ${ODS2CSV_CPP_FILES} ${ODS2CSV_MOC_SRCS})
-  target_include_directories (ods2csv PUBLIC ${Qt5Core_INCLUDES} ${Qt5Gui_INCLUDES} "${CMAKE_SOURCE_DIR}/src")
+  target_include_directories (ods2csv PUBLIC ${Qt5Core_INCLUDES} "${CMAKE_SOURCE_DIR}/src" )
   SET_TARGET_PROPERTIES(ods2csv
       PROPERTIES OUTPUT_NAME ods2tsv
       CLEAN_DIRECT_OUTPUT 1
-      CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS} ${Qt5Gui_EXECUTABLE_COMPILE_FLAGS}"
+      CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS}"
     )
-  TARGET_LINK_LIBRARIES(ods2csv odsstream-shared-qt5 ${Qt5Core_LIBRARIES} ${Qt5Gui_LIBRARIES})
+  TARGET_LINK_LIBRARIES(ods2csv odsstream-shared-qt5 ${Qt5Core_LIBRARIES})
 
   INSTALL(PROGRAMS ${CMAKE_BINARY_DIR}/src/ods2tsv DESTINATION bin)
 
@@ -102,7 +105,11 @@
 
   # Build the static lib
   ADD_LIBRARY(odsstream-static-qt4 STATIC ${CPP_FILES})
-  target_include_directories (odsstream-static-qt4 PUBLIC ${QUAZIP_INCLUDE_DIR} ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTXML_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR})
+  if (NOT CMAKE_VERSION VERSION_LESS 2.8.12)
+       target_include_directories (odsstream-static-qt4 PUBLIC ${QUAZIP_INCLUDE_DIR} ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTXML_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR})
+   else()
+       include_directories(${QUAZIP_INCLUDE_DIR} ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTXML_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR})
+   endif()
   IF (MINGW)
     SET_TARGET_PROPERTIES(odsstream-static-qt4
       PROPERTIES OUTPUT_NAME odsstream-qt4
@@ -120,7 +127,12 @@
 
   # Build the shared lib
   ADD_LIBRARY(odsstream-shared-qt4 SHARED ${CPP_FILES})
-  target_include_directories (odsstream-shared-qt4 PUBLIC ${QUAZIP_INCLUDE_DIR} ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTXML_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR})
+  if (NOT CMAKE_VERSION VERSION_LESS 2.8.12)
+    target_include_directories (odsstream-shared-qt4 PUBLIC ${QUAZIP_INCLUDE_DIR} ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTXML_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR})
+
+   else()
+       include_directories(${QUAZIP_INCLUDE_DIR} ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTXML_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR})
+   endif()
   IF(MINGW)
     SET_TARGET_PROPERTIES(odsstream-shared-qt4
       PROPERTIES OUTPUT_NAME odsstream-qt4
@@ -142,7 +154,8 @@
   TARGET_LINK_LIBRARIES(odsstream-shared-qt4 ${LIBS} ${QT_QTCORE_LIBRARY} ${QT_QTXML_LIBRARY}  ${QUAZIP_QT4_LIBRARIES} ${QT_QTGUI_LIBRARY})
 
   # Install libs
-  INSTALL(TARGETS odsstream-static-qt4 odsstream-shared-qt4 DESTINATION lib${LIB_SUFFIX})
+  INSTALL(TARGETS odsstream-shared-qt4 LIBRARY DESTINATION lib${LIB_SUFFIX})
+  INSTALL(TARGETS odsstream-static-qt4 DESTINATION lib${LIB_SUFFIX})
 
 ENDIF(USEQT4)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -36,8 +36,8 @@
 
 IF (USEQT5)
   IF (USEQT4)
-     SET (USEQT5 0)
-     SET (USEQT4 1)
+     SET (USEQT5 1)
+     SET (USEQT4 0)
   ENDIF(USEQT4)
 ENDIF(USEQT5)

=== debian/changelog ===
libodsstream (0.4.13-2) unstable; urgency=medium

  * Fix cmake find script

 -- Olivier Langella <olivier.langella@u-psud.fr>  Mon, 19 Feb 2018 12:21:23 +0100

libodsstream (0.4.13-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * cme fix dpkg-control

 -- Andreas Tille <tille@debian.org>  Mon, 12 Feb 2018 09:54:20 +0100

libodsstream (0.4.12-1) unstable; urgency=medium

  [ Olivier Langella ]
  * first attempt to build an official debian package

  [ Andreas Tille ]
  * Add watch file
  * Set Debichem team as maintainer
  * Add Vcs fields
  * cme fix dpkg-control
  * source/format: 3.0 (quilt)
  * remove dbgsym packages
  * d/rules: short dh
  * Add missing Build-Depends: cmake
  * debhelper 10
  * Standards-Version: 4.1.2

 -- Olivier Langella <olivier.langella@u-psud.fr>  Tue, 14 Nov 2017 14:53:53 +0100

libodsstream (0.4.10-1) stretch; urgency=medium

  * bug fixed writing URL cells

 -- Olivier Langella <olivier.langella@u-psud.fr>  Sun, 13 Aug 2017 14:34:21 +0200

libodsstream (0.4.9-1) stretch; urgency=medium

  * virtual function to write sheetname

 -- Olivier Langella <olivier.langella@u-psud.fr>  Tue, 20 Jun 2017 21:38:56 +0200

libodsstream (0.4.8-2) stretch; urgency=medium

  * first stetch package

 -- Olivier Langella <olivier.langella@u-psud.fr>  Tue, 20 Jun 2017 17:15:08 +0200

libodsstream (0.4.6-2) stretch; urgency=medium

  * stretch package

 -- Olivier Langella <olivier.langella@u-psud.fr>  Sat, 17 Dec 2016 07:47:07 +0100

libodsstream (0.4.5-3) stretch; urgency=medium

  * cmake 3.7 

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Sun, 20 Nov 2016 16:12:52 +0100

libodsstream (0.4.5-2) stretch; urgency=medium

  * install cmake module

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Sat, 03 Sep 2016 14:07:28 +0200

libodsstream (0.4.5-1) stretch; urgency=medium

  * package for stretch

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Thu, 25 Aug 2016 21:53:45 +0200

=== debian/control ===
Source: libodsstream
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Olivier Langella <olivier.langella@u-psud.fr>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 10),
               cmake,
               d-shlibs,
               qtbase5-dev,
               libquazip5-dev,
               libquazip-dev,
               doxygen
Standards-Version: 4.1.3
Vcs-Browser: https://anonscm.debian.org/cgit/debichem/packages/libodsstream.git
Vcs-Git: https://anonscm.debian.org/git/debichem/packages/libodsstream.git
Homepage: http://pappso.inra.fr/bioinfo

Package: libodsstream-qt5-0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: C++ library to read or write ODS files
 libodsstream provides a simple way to read and write Open 
 Document Spreadsheet files using streams only to be memory efficient.
 .
 This package contains the shared library.

Package: libodsstream-qt5-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libodsstream-qt5-0 (= ${binary:Version}),
         ${misc:Depends},
         libquazip-dev
Description: C++ library to read or write ODS files (development files)
 libodsstream provides a simple way to read and write Open 
 Document Spreadsheet files using streams only to be memory efficient.
 .
 This package contains the header files of the library.

Package: libodsstream-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: doxygen documentation of the ODSstream library
 libodsstream provides a simple way to read and write Open 
 Document Spreadsheet files using streams only to be memory efficient.
 .
 This package provides the documentation of the library.

Package: ods2tsv
Architecture: any
Depends: ${shlibs:Depends},
         libodsstream-qt5-0 (= ${binary:Version}),
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ODS to TSV file converter
 Simple command line interface utility that takes one or more ods files
 as input and convert them into tabulated separated value (simple text files).
 Each ods file will create an output directory of the same name, containing all
 the spreadsheets (one tsv file per spreadsheet).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" -DCMAKE_INSTALL_PREFIX=/usr -DUSEQT4=0 -DUSEQT5=1 -DCMAKE_BUILD_TYPE=Release -DCMAKE_SKIP_RPATH=1

override_dh_auto_build:
	dh_auto_build -- doc

# That's a bit hackish but solved the lintian error about private cmake files
override_dh_install:
	dh_install
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --override 's/libQt5[CGX][oreuiml]\+5-dev/qtbase5-dev/' \
		    --override 's/libquazip5-1-dev/libquazip5-dev/' \
		    --exclude-la \
                    --movedev debian/tmp/usr/include/odsstream usr/include \
                    --movedev debian/tmp/usr/lib/*/cmake usr/lib/$(DEB_HOST_MULTIARCH) \
                    debian/tmp/usr/lib/*/*.so
